unit Ipxesr;

{ This unit contains the Event Service Routine for IPX ECBS }

{$C FIXED PRELOAD PERMANENT }

interface

uses NXTW, WinTypes, Messages;

type XECB = record
       BaseECB: ECB;
       Wnd    : HWND;
       Msg    : WORD;
       end;

type PECB  = ^ECB;
     PXECB = ^XECB;
     PIPXHeader  = ^IPXHeader;
     PIPXAddress = ^IPXAddress;
     PSPXHeader  = ^SPXHeader;

{ TOTALLY ARBITRARY... MIGHT USE RegisterWindowMessage INSTEAD }
const WM_SPXLISTENFORCONNECTION = WM_USER + $300;
      WM_SPXESTABLISHCONNECTION = WM_USER + $301;
      WM_SPXRECEIVE             = WM_USER + $302;
      WM_SPXSEND                = WM_USER + $303;
      WM_IPXECBCOMPLETE         = WM_USER + $304;

{ The SAP broadcast server structure }
type PSAPServer = ^TSAPServer;
     TSAPServer = record
       ServerType: Word; { big endian }
       ServerName: array[0..47] of char;
       Network   : array[0..3] of byte;
       Node      : array[0..5] of byte;
       Socket    : Word;           { big endian }
       InterveningNetworks: Word;  { big endian }
       end;

     PSAPServiceID = ^TSAPServiceID;
     TSAPServiceID = record
       ResponseType: Word;    { big endian }
       Server      : array[0..6] of TSAPServer;
       end;

     PSAPQuery = ^TSAPQuery;
     TSAPQuery = record
       QueryType : Word;    { big endian }
       ServerType: Word;    { big endian }
       end;

procedure Esr; export;

implementation

uses WinProcs;

procedure Esr;
var OurECB: PXECB;
    EsrEs : Word;
    EsrSi : word;
begin
   asm
      mov ax,es
      mov EsrEs,ax
      mov EsrSi,si
   end;

   OurECB := PXECB(MakeLong(EsrSi, EsrEs));

   if OurECB^.Wnd <> 0 then
      { The possibility that PostMessage might return false is ignored }
      { Returning false would indicate that the target's message queue }
      { is full and would result in the data in this ECB begin "lost". }
      PostMessage(OurECB^.Wnd, OurECB^.Msg, 0, Longint(OurECB))
end;

initialization
   { Page-lock the Event Service Routine }
   { This keeps the memory manager from paging this routine to disk }
   { VERY IMPORTANT }
   GlobalPageLock(SelectorOf(@Esr));
end.

