unit Spxdemo1;

{ This example demonstrates the use of SPX.  SPX, although complicated }
{ to use (compared to other transport API), offers some of the highest }
{ performance of all the transports.  This example allows you to enter }
{ the network and node address of a remote and send your time back and }
{ forth between each other.  Start a copy on two different machines or }
{ connect to yourself using one copy on your local machine.  You must  }
{ have the Apiary Developer's Suite for NetWare, Delphi Edition for    }
{ this example to compile.                                             }

{ Brad Greenway - Apiary, Inc. - May 24, 1995                          }
{ CompuServe: 74431,1407                                               }
{ Voice: (501) 221-3699   Fax: (501) 221-7412                          }
{ This is an unsupported product - Phone calls should be for product   }
{ inquiries and ordering only.                                         }

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, NXTW, IpxMisc, IpxEsr, NWCalDef;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Call: TButton;
    Send: TButton;
    Label3: TLabel;
    Edit1: TEdit;
    Label4: TLabel;
    Edit2: TEdit;
    ListBox1: TListBox;
    Label5: TLabel;
    ListBox2: TListBox;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    procedure SendClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure CallClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure MsgSpxListenForConnection(var TheMessage : TMessage); message WM_SPXLISTENFORCONNECTION;
    procedure MsgSpxReceive(var TheMessage : TMessage); message WM_SPXRECEIVE;
    procedure MsgSpxSend(var TheMessage : TMessage); message WM_SPXSEND;
    function IPXAddressToStr(AnIPXAddress : IPXAddress): string;
  end;

var
  Form1    : TForm1;
  IPXTaskID: DWord;
  MyECBs   : array[0..9] of PXECB;
  SocketNum: Word;
  ConnID   : Word;
  Remote   : IPXAddress;

implementation

{$R *.DFM}

function TForm1.IPXAddressToStr(AnIPXAddress: IPXAddress): string;
var Tmp: string;
begin
   with AnIPXAddress do
      Tmp := IntToHex(Network[0],2) + IntToHex(Network[1],2)+
             IntToHex(Network[2],2) + IntToHex(Network[3],2)+':'+
             IntToHex(Node[0],2) + IntToHex(Node[1],2)+
             IntToHex(Node[2],2) + IntToHex(Node[3],2)+
             IntToHex(Node[4],2) + IntToHex(Node[5],2);
    IPXAddressToStr := Tmp;
end;

procedure TForm1.MsgSpxListenForConnection(var TheMessage: TMessage);
var MyECB : PXECB;
    C_INFO: CONNECTION_INFO;
begin
   MessageBeep(MB_ICONASTERISK);
   MyECB := PXECB(TheMessage.LParam);
   case MyEcb^.BaseEcb.CompletionCode of
       SPX_CONNECTION_STARTED: begin
          { Dig out the connection ID }
          ConnID := (PWord(@MyEcb^.BaseEcb.IPXWorkspace))^;
          { Get the remote station's address }
          SPXGetConnectionStatus(IPXTaskID,ConnID,C_INFO);
          Move(C_INFO.Destination, Remote, SizeOf(Remote));
          Label8.Caption := IPXAddressToStr(Remote);
          Label2.Caption := 'Connected';
          Call.Caption := '&Hangup';
          Send.Enabled := True;
          end;
       SPX_CONNECTION_TABLE_FULL:
           { Test for error condition if desired };
       else
           { Trap errors if desired };
       end;
end;

procedure TForm1.MsgSpxReceive(var TheMessage: TMessage);
var MyECB: PXECB;
    Head : PSPXHeader;
begin
   MyECB := PXECB(TheMessage.LParam);
   case MyEcb^.BaseEcb.CompletionCode of
       SUCCESSFUL: begin
          Head := PSPXHeader(MyEcb^.BaseEcb.FragmentDescriptor[0].Address);
          { Is this a connection terminated message? }
          if (Head^.DataStreamType = $FE) then begin
             ConnID := 0;
             SPXListenForSequencedPacket(IPXTaskID, PECB(MyEcb)^);
             SPXListenForConnection(IPXTaskID, 0, $ff, PEcb(MyEcbs[0])^);
             Label2.Caption := 'Unconnected';
             Call.Caption := '&Call';
             Send.Enabled := False;
             Label8.Caption := '';
             MessageBeep(MB_ICONHAND);
             end
          else begin
             MessageBeep(MB_ICONQUESTION);
             ListBox2.Items.Add(StrPas(PChar(MyEcb^.BaseEcb.FragmentDescriptor[1].Address)));
             SPXListenForSequencedPacket(IPXTaskID, PECB(MyEcb)^);
             end;
          end;
       SPX_PACKET_OVERFLOW: begin
          { Packet too big to receive - It is lost }
          SPXListenForSequencedPacket(IPXTaskID, PECB(MyEcb)^);
          end;
       else begin
          { ERROR }
          SPXAbortConnection(ConnID);
          ConnID := 0;
          SPXListenForSequencedPacket(IPXTaskID, PECB(MyEcb)^);
          SPXListenForConnection(IPXTaskID, 0, $ff, PEcb(MyEcbs[0])^);
          Label2.Caption := 'Unconnected';
          Call.Caption := '&Call';
          Label8.Caption := '';
          Send.Enabled := False;
          end;
       end;
end;

procedure TForm1.MsgSpxSend(var TheMessage: TMessage);
var MyECB: PXECB;
begin
   MyECB := PXECB(TheMessage.LParam);
   case MyEcb^.BaseEcb.CompletionCode of
      SUCCESSFUL:
         ListBox1.Items.Add(StrPas(PChar(MyEcb^.BaseEcb.FragmentDescriptor[1].Address)));
      end;
end;

procedure TForm1.SendClick(Sender: TObject);
var Ecb: PXEcb;
begin
   Ecb := nil;
   if MyEcbs[6]^.BaseEcb.InUseFlag = 0 then
      Ecb := MyEcbs[6]
   else if MyEcbs[7]^.BaseEcb.InUseFlag = 0 then
      Ecb := MyEcbs[7]
   else if MyEcbs[8]^.BaseEcb.InUseFlag = 0 then
      Ecb := MyEcbs[8]
   else if MyEcbs[9]^.BaseEcb.InUseFlag = 0 then
      Ecb := MyEcbs[9];

   if Ecb <> nil then begin
      { data being sent is the time of day.  At random the program }
      { sends 'Lunch Time' instead (just for variety).             }
      if Random(10) <> 4 then
         StrPCopy(PChar(Ecb^.BaseEcb.FragmentDescriptor[1].Address), TimeToStr(Time))
      else
         StrPCopy(PChar(Ecb^.BaseEcb.FragmentDescriptor[1].Address), 'Lunch Time');
      SPXSendSequencedPacket(IPXTaskID,ConnID,PEcb(Ecb)^);
      end;
end;

procedure TForm1.FormShow(Sender: TObject);
var MajRev   : Byte;
    MinRev   : Byte;
    MaxConn  : Word;
    AvailConn: Word;
    Count    : Word;
    Ret      : Integer;
    Address  : IPXAddress;
begin
   if SPXInitialize(IPXTaskID, 0, 0, MajRev, MinRev, MaxConn, AvailConn) <> SPX_INSTALLED then begin
      MessageDlg('SPX DRIVERS WERE NOT FOUND', mtError, [mbOK], 0);
      Close;
      end;
   { $4500 = Arbitrary number/Might want to change }
   SocketNum := swap($4500);
   { Ecb for SPXListenForConnection }
   MyECBs[0] := alloc_ECB(SPX_PACKET, SocketNum, 0, WM_SPXLISTENFORCONNECTION);
   MyECBs[0]^.Wnd := Handle;
   { Ecb for SPXEstablishConnection }
   MyECBs[1] := alloc_ECB(SPX_PACKET, SocketNum, 0, 0);
   { We will do establish connection synchronously }
   MyEcbs[1]^.BaseEcb.EsrAddress := nil;
   { Ecbs for SPXListenForSequencedPacket }
   for Count := 2 to 5 do begin
      MyECBs[Count] := alloc_ECB(SPX_PACKET, SocketNum, 576, WM_SPXRECEIVE);
      MyECBs[Count]^.Wnd := Handle;
      end;
   { Ecbs for SPXSendSequencedPacket }
   for Count := 6 to 9 do begin
      MyECBs[Count] := alloc_ECB(SPX_PACKET, SocketNum, 576, WM_SPXSEND);
      MyECBs[Count]^.Wnd := Handle;
      end;
   IPXOpenSocket(IPXTaskID, SocketNum, 0);
   { Post our receives }
   for Count := 2 to 5 do
      SPXListenForSequencedPacket(IPXTaskID, PECB(MyEcbs[Count])^);
   { Post a listen }
   SPXListenForConnection(IPXTaskID, 0, $ff, PEcb(MyEcbs[0])^);

   { Fill the edit control with our local network }
   IPXGetInternetworkAddress(IPXTaskID, Address);
   with Address do begin
      Edit1.Text := IntToHex(Network[0],2) + IntToHex(Network[1],2) +
                    IntToHex(Network[2],2) + IntToHex(Network[3],2);
      Edit2.Text := '';
      Edit2.Text := IntToHex(Node[0],2) + IntToHex(Node[1],2) +
                    IntToHex(Node[2],2) + IntToHex(Node[3],2) +
                    IntToHex(Node[4],2) + IntToHex(Node[5],2);
      end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
var Ecb  : PXEcb;
    Count: Word;
begin
   { If ecbs were never allocated, the rest of this code is unnecessary }
   if MyEcbs[0] = nil then
      Exit;
   { Stop listening, if necessary }
   if MyECBs[0]^.BaseEcb.InUseFlag <> 0 then
      IPXCancelEvent(IPXTaskID, PECB(MyECBs[0])^);
   { Break the connection, if necessary }
   if ConnID <> 0 then begin
      Ecb := alloc_ecb(SPX_PACKET, SocketNum, 0, 0);
      SPXTerminateConnection(IPXTaskID, ConnID, PECB(Ecb)^);
      while Ecb^.BaseEcb.InUseFlag <> 0 do
         {nothing};
      SPXAbortConnection(ConnID);
      free_ecb(Ecb);
      end;
   { Cancel any pending SPXSendSequencedPacket }
   for Count := 2 to 5 do
      IPXCancelEvent(IPXTaskID, PECB(MyECBs[Count])^);
   { Cancel any pending SPXListenForSequencedPacket }
   for Count := 6 to 9 do
      IPXCancelEvent(IPXTaskID, PECB(MyECBs[Count])^);
   { Finally (WHEW!!) free all ecbs }
   for Count := 0 to 9 do
       free_ECB(MyECBs[Count]);
    IPXSPXDeinit(IPXTaskID);
end;

procedure TForm1.CallClick(Sender: TObject);
var Head    : PIPXHeader;
    Ret     : Word;
    RAddress: string;
    Ecb     : PXEcb;
begin
   if ConnID <> 0 then begin
      Ecb := alloc_ecb(SPX_PACKET, SocketNum, 0, 0);
      SPXTerminateConnection(IPXTaskID, ConnID, PECB(Ecb)^);
      while Ecb^.BaseEcb.InUseFlag <> 0 do
         {nothing};
      SPXAbortConnection(ConnID);
      free_ecb(Ecb);
      ConnID := 0;
      Label2.Caption := 'Unconnected';
      Call.Caption := '&Call';
      Send.Enabled := False;
      Label8.Caption := '';
      Exit;
      end;

   Head := PIPXHeader(MyECBs[1]^.BaseEcb.FragmentDescriptor[0].address);
   RAddress := Edit1.Text;
   { Fill the destination network }
   Head^.Destination.Network[0] := StrToInt('$'+Copy(RAddress, 1, 2));
   Head^.Destination.Network[1] := StrToInt('$'+Copy(RAddress, 3, 2));
   Head^.Destination.Network[2] := StrToInt('$'+Copy(RAddress, 5, 2));
   Head^.Destination.Network[3] := StrToInt('$'+Copy(RAddress, 7, 2));

   RAddress := Edit2.Text;
   { Fill the destination node }
   Head^.Destination.Node[0] := StrToInt('$'+Copy(RAddress, 1, 2));
   Head^.Destination.Node[1] := StrToInt('$'+Copy(RAddress, 3, 2));
   Head^.Destination.Node[2] := StrToInt('$'+Copy(RAddress, 5, 2));
   Head^.Destination.Node[3] := StrToInt('$'+Copy(RAddress, 7, 2));
   Head^.Destination.Node[4] := StrToInt('$'+Copy(RAddress, 9, 2));
   Head^.Destination.Node[5] := StrToInt('$'+Copy(RAddress, 11, 2));

   { Now change destination socket to $4500 = Arbitrary value }
   Head^.Destination.Socket[0] := $45;
   Head^.Destination.Socket[1] := $00;

   Call.Enabled := False;
   Ret := SPXEstablishConnection(IPXTaskID, 0, $FF, ConnID, PEcb(MyEcbs[1])^);
   if Ret = 0 then begin
      while MyEcbs[1]^.BaseEcb.InUseFlag <> 0 do
         {nothing};
      if MyEcbs[1]^.BaseEcb.completionCode = SPX_CONNECTION_STARTED then begin
         Label2.Caption := 'Connected';
         Call.Caption := '&Hangup';
         Send.Enabled := True;
         Label8.Caption := IPXAddressToStr(Head^.Destination);
         end
      else
         MessageDlg('Remote machine did not answer',mtError,[mbOk],0);
      end
   else begin
      MessageDlg('Error in address',mtError,[mbOk],0);
      end;
   Call.Enabled := True;
end;

end.

